config/routes.rb
Rails.application.routes.draw do
  resources :phone_lists
  get 'map' ,to:'map#show'

  get 'admin' ,to:'links#admin'
  
  devise_for :users
  resources :links do
    resources :students
  end

  resources :users, only: [:index, :destroy]
  resources :users
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html
  
  # Defines the root path route ("/")
  root to: 'links#index'
  # root "articles#index"
end

app/models/link.rb
class Link < ApplicationRecord
    validates_presence_of :name, :url
    validates :ruch_emergency, inclusion: { in: ['YES','yes','Yes','No','no', 'Notify'], message: "must be 'YES' or 'NO'" }
    has_many :students
    has_many :users
    # has_many :active_storage_attachments
    has_one_attached :picture

    def owned_by?(user)
        user == self.user
    end

end

app/controllers/links_controller.rb
class LinksController < ApplicationController
  before_action :set_link, only: %i[ show edit update destroy ]
  before_action :authenticate_user!, except: [:index]
  before_action :check_admin_role, only: [:admin]

  # GET /links or /links.json
  def index
    @links = Link.all
  end

  # GET /links/1 or /links/1.json
  def show
  end

  def admin
    @link = Link.all

  end
  
  def destroy_user
    @user = User.find(params[:id])
    @user.destroy

    respond_to do |format|
      format.html { redirect_to admin_links_url, notice: "User was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  # GET /links/new
  def new
    @link = Link.new
  end

  # GET /links/1/edit
  def edit
    # @link = Link.find(params[:id])
    # if @link.user != current_user
    #   flash[:alert] = "You don't have permission to edit this link."
    #   redirect_to @link
    # end
  end

  # POST /links or /links.json
  def create
    @link = Link.new(link_params)

    respond_to do |format|
      if @link.save
        format.html { redirect_to link_url(@link), notice: "Post was successfully created." }
        format.json { render :show, status: :created, location: @link }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @link.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /links/1 or /links/1.json
  def update
    respond_to do |format|
      if @link.update(link_params)
        format.html { redirect_to link_url(@link), notice: "Link was successfully updated." }
        format.json { render :show, status: :ok, location: @link }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @link.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /links/1 or /links/1.json
  def destroy
    @link = Link.find(params[:id])
    @link.students.destroy_all
    @link.destroy


    respond_to do |format|
      format.html { redirect_to links_url, notice: "Post was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_link
      @link = Link.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def link_params
      params.require(:link).permit(:name, :url, :picture, :ruch_emergency, :type_emergency, :user)
    end
    
    def check_admin_role
      if current_user.username != 'admin'

        respond_to do |format|
          format.html { redirect_to links_url, notice: "You don't have permission to access this page." }
          format.json { head :no_content }
        end
      end
    end
end

app/helpers/links_helper.rb
module LinksHelper
end

app/views/links/_form.html.erb
<%= form_with(model: link) do |form| %>
  <% if link.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(link.errors.count, "error") %> prohibited this link from being saved:</h2>

      <ul>
        <% link.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :Name, style: "display: block" %>
    <%= form.text_field :name %>
  </div>

  <div>
    <%= form.label :Description, style: "display: block" %>
    <%= form.text_area :url, style: "resize: both;" %> <!-- Users can adjust size by dragging the corners -->
  </div>

  <div class="field">
    <%= form.label :rush_emergency? %>
    <%= form.select :ruch_emergency, ['Yes', 'No', 'Notify'] %>
  </div>

  <div>
    <%= form.label :type_emergency, style: "display: block" %>
    <%= form.select :type_emergency, ['Harassment', 'Fire', 'Accident', 'Medical', 'Notify'] %>
    <!-- Replace the array with your actual options -->
  </div>

  <div class="field">
    <%= form.label :user %><br />
    <%= form.text_field :user, value: current_user.username, readonly: true %> 
    <!-- readonly: true will make this field can not edit -->
  </div>
  

  <div>
    <%= form.submit "Submit", class:"btn" %>
  </div>
<% end %>

app/views/links/_link.html.erb
<div id="<%= dom_id link %>">

  <p>
    <strong>Title:</strong>
    <%= link.name %>
  </p>

  <strong>Post on :</strong>
  <td><%= link.created_at+25200 %></td>
    
  <p>
    <strong>Description:</strong>
    <%= link.url %>
  </p>

  <p>
    <strong>Rush Emergency ?:</strong>
    <%= link.ruch_emergency %>
  </p>

  <p>
    <strong>Type of Emergency :</strong>
    <% if link.type_emergency == "Harassment" %>
      <span style="color: orange;"><%= link.type_emergency %></span>
    <% elsif link.type_emergency == "Fire" %>
      <span style="color: red;"><%= link.type_emergency %></span>
    <% elsif link.type_emergency == "Accident" %>
      <span style="color: purple;"><%= link.type_emergency %></span>
    <% elsif link.type_emergency == "Medical" %>
      <span style="color: green;"><%= link.type_emergency %></span>
    <% else %>
      <%= link.type_emergency %>
    <% end %>
  </p>

</div>

app/views/links/admin.html.erb
<h1>Admin Zone</h1>

<table>
  <tr>
    <th>Username</th>
    <th>Name of Post</th>
    <th>View</th>
    <th>Destroy Post</th>
  </tr>

  <% @link.each do |link| %>
    <tr>
      <td><%= link.user %></td>
      <td><%= link.name %></td>
      <td><%= button_to link_to "See", link %></td>
      <td>
        <%= button_to 'Destroy Post', link, method: :delete, data: { confirm: 'Are you sure?' } %>
      </td>

    </tr>
  <% end %>
  
</table>


<a class="button" href="<%= links_path %>">Back to Homepage</a>
<a class="button" href="<%= users_path %>">list of user</a>
<a class="button" href="<%= new_phone_list_path %>">Create Phone Number </a>

app/views/links/edit.html.erb
<h1>Editing link</h1>

<%= render "form", link: @link %>

<br>

<div>
  <%= link_to "Show this link", @link %> |
  <%= link_to "Back to links", links_path %>
</div>

app/views/links/index.html.erb
<p style="color: green"><%= notice %></p>
<div id="header">
<img src="<%= asset_path('AIT_logo-1.png') %>" alt="Custom Map" width="500" height="100" />

<!-- <img src="<%= asset_path('AIT_globe.jpg') %>" alt="Custom Map" width="100" height="100" /> -->

<h1 class="letter-sequence">Welcome to AIT Community</h1>
<h4 class="letter-sequence">----------Post some Emergency or Telling somthing---------- </h4>

</div>
<div id="content">
  <a class="button" href="<%= phone_lists_path %>">Phone Lists</a>
  <a class="button" href="<%= new_link_path %>">Notify or tell emergency</a>
  <a class="button" href="<%= map_path %>">See the Map</a>
  <a class="button" href="/admin">Only Admin</a>
  <a class="button" href="https://www.ait.ac.th">AIT site</a>
</div>



<div id="content">
<div id="links">
  <% @links.order(created_at: :desc).each do |link| %>
    <div class="link">
    <%= render link %>
    <p>
      <%= link_to "Comment", link %>
    </p>
    </div>
  <% end %>
</div>
</div>

app/views/links/new.html.erb
<h1>Create New Post</h1>
<p>Tell us or notify someone, what happen... </p>

<%= render "form", link: @link %>

<br>

<div>
  <a class="button" href="<%= links_path %>">Back to Homepage</a>
</div>

app/views/links/show.html.erb
<h2>Comments</h2>
<table>
<table>
<thead>
<tr>
<th>Name </th>
<th>Comment</th>
<th>Post on</th>
</tr>
</thead>
<tbody>
<% @link.students.each do |student| %>
<tr>
<td><%= student.studentid %></td>
<td><%= student.name %></td>
<td><%= student.created_at+25200 %></td>


</tr>
<% end %>

<% if current_user.username == @link.user %>
  <%= link_to "Edit this post", edit_link_path(@link) %> 
<% end %>


<% if @link.user == current_user.username %>
  <%= button_to "Destroy this post", @link, method: :delete %>
<% end %>



</tbody>
</table>
<br/>
<h2>Add a comment:</h2>
<%= form_for([@link, @link.students.build]) do |f| %>

<div class="field">
  <%= f.label :Name %><br />
  <%= f.text_field :studentid, value: current_user.username, readonly: true %> 
  <!-- readonly: true will make this field can not edit -->
</div>

<div class="field">
  <%= f.label :Comment%><br />
  <%= f.text_area  :name %>
</div>

<!-- <div>
    <%= f.file_field :picture %> 
    <%= f.submit %>
</div> -->

<div class="actions">
  <%= f.submit "Comment", class:"btn"%>
</div>

<% end %>
<br />
<%= link_to "Back", links_path %>